<?php
require_once "../../core_factory.php";
$lang_has_changed = Logaholic_hasLangChanged();
$lang = Logaholic_setLang();
?>
// <script>


var showtime;
var step = 0;
var total_steps = 0;
var default_height = "260px";
var default_min_height = "70px";

$(document).ready(function() {
	SetTutorialConfig();

	if(tutorial_settings.height == undefined){
		tutorial_settings.height = default_height;
	}

	// set the height
	$("#tutorialbox").css("height", tutorial_settings.height);


	if(tutorial_settings.min_height == undefined){
		tutorial_settings.min_height = default_min_height;
	}

	total_steps	= tutorial_config.length;

	if(total_steps > 0){
		// start Tutorial
		Tutorial();
		
		// Button handling
		$("#tutorialbox").on("click", "#tutorialstartbutton" ,StartTutorial);
		$("#tutorialbox").on("click",".closeTutorial", CloseTutorial);
	} else {
		$("#tutorialbox").remove();
	}

	// add handling when keyboard buttons are used only use on dev
	// KeyboardHandling();

});

function Tutorial(){	
	var content = "<h1><?php echo _LOGAHOLIC_TUTORIAL; ?> - "+ tutorial_settings.Name +"</h1>" + "<div class='info'>" + tutorial_settings.Intro + "</div>" + StartButton() + CloseButton();
	$("#tutorialbox").html(content);
	$("#tutorialbox").show();
	
	$( "#tutorialbox" ).animate({
		top: "150px"
	}, 1000, function() {
		// Animation complete.
	});
}

function maximizeBox(){
	$( "#tutorialbox" ).animate({
		left : "50%",
		top : "150px",
		height : tutorial_settings.height,
		width : "440px"
	}, 1000, function() {
	});
}
function minimizeBox(){
	$("#tutorialbox .info").html("");
	$( "#tutorialbox" ).animate({
		left : "90%",
		top : "140px",
		height : tutorial_settings.min_height,
		width : "280px"
	}, 1000, function() {
	});
}

function StartButton(){
	return "<a id='tutorialstartbutton'><?php echo _START_TUTORIAL; ?></a>";
}
function CloseButton(){
	return "<div id='tutorialbuttons'><input type='checkbox' name='nevershowagain' /><label><?php echo _NEVER_SHOW_AGAIN; ?></label><a class='closeTutorial'><?php echo _CLOSE; ?></a></div>";
}

function StartTutorial(){
	// extra call because for example: the use might have closed or opened the report panel
	SetTutorialConfig();
	
	$('#tutorialstartbutton').remove();
	minimizeBox();
	showOverlay();
	nextStep();
}

function CloseTutorial(){
	clearTimeout(showtime);

	if($("#tutorialbox input[name='nevershowagain']").is(":checked")){
		var d = new Date();
		d.setTime(d.getTime() + (1365*24*60*60*1000));
		document.cookie = "hideTutorial=1; expires="+ d.toGMTString();
	}

	$('#tutorialbox').remove();
	$('#tour_overlay').remove();
	$('#tour_tooltip').remove();
}

function EndTutorial(){
	removeTooltip();
	maximizeBox();

	var content = "<h1><?php echo _LOGAHOLIC_TUTORIAL; ?> - "+ tutorial_settings.Name +"</h1>" + "<p class='info'>" + tutorial_settings.End + "</p>" + CloseButton();
	$("#tutorialbox").html(content);
}

function KeyboardHandling(){
	document.body.onkeyup = function(event){
		event = event || window.event;
		var keycode = event.charCode || event.keyCode;
		if(keycode === 107){
			nextStepOnKey();
		}
	}
}

function nextStepOnKey(){
	clearTimeout(showtime);
	nextStep();
}

function nextStep(){	
	if(step >= total_steps){
		//if last step then end tour
		EndTutorial();
		return false;
	}
	++step;
	showTooltip();
}

function removeTooltip(){
	$('#tour_tooltip').remove();
}

function showOverlay(){
	var $overlay	= '<div id="tour_overlay" class="overlay"></div>';
	$('BODY').prepend($overlay);
}

function showTooltip(){
	//remove current tooltip
	removeTooltip();
	
	var step_config		= tutorial_config[step-1];
	var $elem			= $('.' + step_config.target_class);
	
	showtime	= setTimeout(nextStep,step_config.time);
	
	// is the background color defined ?
	if(step_config.bgcolor != undefined){
		var bgcolor = step_config.bgcolor;
	} else {
		var bgcolor = "#333333";
	}

	// is the textcolor defined ?
	if(step_config.color != undefined){
		var color = step_config.color;
	} else {
		var color = "white";
	}
	
	
	var $tooltip		= $('<div>',{
		id			: 'tour_tooltip',
		className 	: 'tooltip',
		html		: '<p>'+step_config.text+'</p><span class="tooltip_arrow"></span>'
	}).css({
		'display'			: 'none',
		'background-color'	: bgcolor,
		'color'				: color
	});

	// check for callback
	if (step_config.startcall != undefined && typeof(step_config.startcall) === "function") {
		step_config.startcall();
	}
	
	//position the tooltip correctly:
	
	//the css properties the tooltip should have
	var properties		= {};
	
	var tip_position 	= step_config.position;
	
	//append the tooltip but hide it
	$('BODY').prepend($tooltip);


	// do we need to adjust the box a bit left or right?
	var adjust_left = 0;
	if(step_config.adjust_left != undefined){
		adjust_left = step_config.adjust_left;
	}

	// do we need to adjust the box a bit up or down?
	var adjust_top = 0;
	if(step_config.adjust_top != undefined){
		adjust_top = step_config.adjust_top;
	}


	//get some info of the element
	var e_w				= $elem.outerWidth();
	var e_h				= $elem.outerHeight();
	var e_l				= $elem.offset().left + parseInt(adjust_left);
	var e_t				= $elem.offset().top + parseInt(adjust_top);
	
	
	switch(tip_position){
		case 'TL'	:
			properties = {
				'left'	: e_l,
				'top'	: e_t + e_h + 8 + 'px'
			};
			$tooltip.find('span.tooltip_arrow').addClass('tooltip_arrow_TL');
			break;
		case 'TR'	:
			properties = {
				'left'	: e_l + e_w - $tooltip.width() + 'px',
				'top'	: e_t + e_h + 'px'
			};
			$tooltip.find('span.tooltip_arrow').addClass('tooltip_arrow_TR');
			break;
		case 'BL'	:
			properties = {
				'left'	: e_l + 'px',
				'top'	: e_t - $tooltip.height() + 'px'
			};
			$tooltip.find('span.tooltip_arrow').addClass('tooltip_arrow_BL');
			break;
		case 'BR'	:
			properties = {
				'left'	: e_l + e_w - $tooltip.width() + 'px',
				'top'	: e_t - $tooltip.height() + 'px'
			};
			$tooltip.find('span.tooltip_arrow').addClass('tooltip_arrow_BR');
			break;
		case 'CL'	:
			properties = {
				'left'	: '45%',
				'top'	: '200px'
			};
			//$tooltip.find('span.tooltip_arrow').addClass('tooltip_arrow_L');
		break;
		case 'LT'	:
			properties = {
				'left'	: e_l + e_w + 'px',
				'top'	: e_t + 'px'
			};
			$tooltip.find('span.tooltip_arrow').addClass('tooltip_arrow_LT');
			break;
		case 'LB'	:
			properties = {
				'left'	: e_l + e_w + 'px',
				'top'	: e_t + e_h - $tooltip.height() + 'px'
			};
			$tooltip.find('span.tooltip_arrow').addClass('tooltip_arrow_LB');
			break;
		case 'RT'	:
			properties = {
				'left'	: e_l - $tooltip.width() + 'px',
				'top'	: e_t + 'px'
			};
			$tooltip.find('span.tooltip_arrow').addClass('tooltip_arrow_RT');
			break;
		case 'RB'	:
			properties = {
				'left'	: e_l - $tooltip.width() + 'px',
				'top'	: e_t + e_h - $tooltip.height() + 'px'
			};
			$tooltip.find('span.tooltip_arrow').addClass('tooltip_arrow_RB');
			break;
		case 'T'	:
			properties = {
				'left'	: e_l + e_w/2 - $tooltip.width()/2 + 'px',
				'top'	: e_t + e_h + 8 + 'px'
			};
			$tooltip.find('span.tooltip_arrow').addClass('tooltip_arrow_T');
			break;
		case 'R'	:
			properties = {
				'left'	: e_l - $tooltip.width() + 'px',
				'top'	: e_t + e_h/2 - $tooltip.height()/2 + 'px'
			};
			$tooltip.find('span.tooltip_arrow').addClass('tooltip_arrow_R');
			break;
		case 'B'	:
			properties = {
				'left'	: e_l + e_w/2 - $tooltip.width()/2 + 'px',
				'top'	: e_t - $tooltip.height() + 'px'
			};
			$tooltip.find('span.tooltip_arrow').addClass('tooltip_arrow_B');
			break;
		case 'L'	:
			properties = {
				'left'	: e_l + e_w  + 'px',
				'top'	: e_t + e_h/2 - $tooltip.height()/2 + 'px'
			};
			$tooltip.find('span.tooltip_arrow').addClass('tooltip_arrow_L');
			break;
	}
	
	/*
	if the element is not in the viewport
	we scroll to it before displaying the tooltip
	 */
	var w_t	= $(window).scrollTop();
	var w_b = $(window).scrollTop() + $(window).height();
	//get the boundaries of the element + tooltip
	var b_t = parseFloat(properties.top,10);
	
	if(e_t < b_t)
		b_t = e_t;
	
	var b_b = parseFloat(properties.top,10) + $tooltip.height();
	if((e_t + e_h) > b_b)
		b_b = e_t + e_h;
		
	
	if((b_t < w_t || b_t > w_b) || (b_b < w_t || b_b > w_b)){
		$('html, body').stop()
		.animate({scrollTop: b_t}, 500, 'easeInOutExpo', function(){
			//need to reset the timeout because of the animation delay			
			clearTimeout(showtime);
			showtime = setTimeout(nextStep,step_config.time);
			
			//show the new tooltip
			$tooltip.css(properties).show();
		});
	}
	else
	//show the new tooltip
		$tooltip.css(properties).show();
}


// </script>