<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
include_once("common.inc.php");
AccessCheck();

if (!isset($_GET['labels'])) { die('missing required parameter'); }
if (!isset($_GET['conf'])) { die('missing required parameter'); }

echo $template->HTMLheadTag();

echo "<body>";

if(!$session->canEditProfiles()) {
	echoNotice("Sorry, you don't have permissions to access this page.","width:400px;margin:0 auto;");
	exit;
}

# Get Label from URL
$labels = $_GET['labels'];

if(defined($labels)) {
	$clabel = $labels;
	$labels = constant($labels);
} else {
	$clabel = $get_constant[$labels];
}

if(empty($clabel) || empty($reports[$clabel]) ){
	echoNotice("Sorry, you don't have permissions to access this page.","width:400px;margin:0 auto;");
	exit;
}

# Setup Report
$r = new $reports[$clabel]["ClassName"]();

# If we dont do this we got holes in our data and reimport wil never import the missing gap again.
$from = $r->from;
$to = $r->dbMinimumDate;

# Get date info for daterange
$daterange_from = date(implode($profile->dateFormat),$_GET['from']);
$daterange_to = date(implode($profile->dateFormat),$_GET['to']);

# Get date info for import data
$import_from = date(implode($profile->dateFormat), $_GET['import_from'] );
$import_to = date(implode($profile->dateFormat),$to);


echo "<div style='width:90%; margin:10px; text-align:center;'>";
if( empty($r->ReIm) ){
	echo "<h3>Missing data in the database.</h3>";
	echo "<p>Given daterange: <b>{$daterange_from} - {$daterange_to}</b> is missing data!</p>";
	echo "You can reimport data from <b>{$import_from} - {$import_to}</b><br/>";	
}


$url = "reimport.php?conf={$profile->profilename}&labels={$clabel}";
$btnStyle = "background-color: #2B4C74;
	border: 1px solid #2D4F7D;
	border-radius: 4px 4px 4px 4px;
	color: #FFFFFF;
	padding: 5px 10px;
	margin: 0 10px;
	text-align: center;
	text-decoration: none;";
	
if( empty($r->ReIm) ){
	echo "<br/><br/>";
	echo "<a style='{$btnStyle} width:100px;' href='{$url}&from={$_GET['from']}&to={$_GET['to']}&import_from={$_GET['import_from']}&ReIm=1'>Import Now!</a>";
	echo "<br/><br/>";
	echoNotice("Close this dialog if you do not want to import data.","margin-top:20px;");
} else {
	# ReimportLogFiles
	$r->ReimportLogFiles($from,$to);
		
	echoNotice("Please close this dialog and reload your report.");
}
echo "</div>";
?>