<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
// $conf = "Profiles";  // No profile name here, so we need to set one (otherwise we'll be redirected).
  
include_once("../common.inc.php");
include_once("session.php");
$baseurl = dirname(dirname(currentScriptURL() . "a"))."/"; // strip off the current script name *and* user_login path.


/**
 * User not an administrator, Show an error message.
 */
if ((!$session->isAdmin()) && ($userAuthenticationType != USER_AUTHENTICATION_NONE)) {
  echo $template->NoAccess(_NO_PERMISSION_FOR_ADMIN_AREA. ".<br><a href='profiles.php'>Click here to continue.</a>");
  exit();
}

include_once "../top.php";
echo "<div class=\"indentbody\">\n";

# get total number of users
$q = $db->Execute("select count(*) from ".TBL_USERS);
$total_users = $q->FetchRow();
$total_users = $total_users[0];

# get number of user that never logged in
$q = $db->Execute("select count(*) from ".TBL_USERS." where lastlogin=''");
$no_login = $q->FetchRow();
$no_login = $no_login[0];

$active_users = $total_users - $no_login;

$no_login_perc = intval(($no_login / $total_users) * 100);


echo "$no_login users of $total_users total users have never logged in, that's $no_login_perc% !";

# get number of user that logged in in the last x days
$intervals[] = 30;
$intervals[] = 60;
$intervals[] = 90;
$intervals[] = 120;
$intervals[] = 150;
$intervals[] = 180;
foreach ($intervals as $days) {
	$lastdays = time() - ($days * 86400);
	$q = $db->Execute("select count(*) from ".TBL_USERS." where lastlogin > $lastdays");
	$last = $q->FetchRow();
	$last = $last[0];

	$last_perc = intval(($last / $total_users) * 100);
	$last_perc_active = intval(($last / $active_users) * 100);
	
	echo "<br>Only $last users logged in in the last $days days ($last_perc %)";
	echo "<br>That's $last_perc_active % of active users<br>";
}




?>
